


QuickPasswords.Util = {
	ConsoleService: null,
    mAppver: null,
    mAppName: null,
    mHost: null,
    lastTime: 0,
    fx4MyVersion: '',

    $: function(id) {
        return document.getElementById(id);
    } ,

    getAddon: function(aId) {
	    var em = Components.classes["@mozilla.org/extensions/manager;1"]
                  .getService(Components.interfaces.nsIExtensionManager);
        return em.getItemForID(aId);
    },

    ExtensionVersion: function() {
	    var aId = "QuickPasswords@axelg.com";
	    if (this.Application()=='Firefox' && this.Appver()>=4) {
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			AddonManager.getAddonByID(aId, function(addon) {
				// This is an asynchronous callback function that might not be called immediately, ah well...
				QuickPasswords.Util.fx4MyVersion = addon.version;
			});
			return QuickPasswords.Util.fx4MyVersion;
	    }
	    else
	    	return this.getAddon(aId).version;
    },

    AppverFull: function() {
	    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
	                    .getService(Components.interfaces.nsIXULAppInfo);
        return appInfo.version;
    },

    Appver: function() {
        if (null == this.mAppver) {
	    var appVer=this.AppverFull().substr(0,3); // only use 1st three letters - that's all we need for compatibility checking!
		    this.mAppver = parseFloat(appVer); // quick n dirty!
        }
		return this.mAppver;
    },

    Application: function() {
		if (null==this.mAppName) {
        var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                        .getService(Components.interfaces.nsIXULAppInfo);
			const FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
			const THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
			const SEAMONKEY_ID = "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}";
			const POSTBOX_ID = "postbox@postbox-inc.com";
			switch(appInfo.ID) {
				case FIREFOX_ID:
				  return this.mAppName='Firefox';
				case THUNDERBIRD_ID:
				  return this.mAppName='Thunderbird';
				case SEAMONKEY_ID:
				  return this.mAppName='SeaMonkey';
				case POSTBOX_ID:
				  return this.mAppName='Postbox';
				default:
				  this.mAppName=appInfo.name;
				  this.logDebug ( 'Unknown Application: ' + appInfo.name);
				  return appInfo.name;
			}
        }
	    return this.mAppName;
    },

    HostSystem: function() {
		if (null==this.mHost) {
			var osString = Components.classes["@mozilla.org/xre/app-info;1"]
		                .getService(Components.interfaces.nsIXULRuntime).OS;
			this.mHost = osString.toLowerCase();
        }
        return this.mHost; // linux - winnt - darwin
    },

    copyStringToClipboard: function(sString) {
       var service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
       var clipboardhelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
	   clipboardhelper.copyString(sString);
    },


    debugVar: function(value) {
        str = "Value: " + value + "\r\n";
        for(prop in value) {
            str += prop + " => " + value[prop] + "\r\n";
        }

        this.logDebug(str);
    },

    logTime: function() {
	    var timePassed = '';
	    try {
		    var end= new Date();
		    var endTime = end.getTime();
			var elapsed = new String(endTime  - this.lastTime); // time in milliseconds
			timePassed = '[' + elapsed + ' ms]   ';
		    this.lastTime = endTime; // remember last time
        }
        catch(e) {;}
	    return end.getHours() + ':' + end.getMinutes() + ':' + end.getSeconds() + '.' + end.getMilliseconds() + '  ' + timePassed;
    },

    logToConsole: function (msg) {
	  if (this.ConsoleService == null)
	    this.ConsoleService = Components.classes["@mozilla.org/consoleservice;1"]
	                               .getService(Components.interfaces.nsIConsoleService);
	  this.ConsoleService.logStringMessage("QuickPasswords " + this.logTime() + "\n"+ msg);
	},

    logDebug: function (msg) {
	  if (QuickPasswords.Preferences.isDebug())
	    this.logToConsole(msg);
	},

    logDebugOptional: function (option, msg) {
	  if (QuickPasswords.Preferences.isDebugOption(option))
	    this.logToConsole(msg);
	},

	about: function() {
		// show the built in about dialog:
		//window.opener.gExtensionsView.builder.rebuild();
		window.opener.gExtensionsViewController.doCommand('cmd_about');
	},

	onLoadOptions: function() {
		document.getElementById('qp-options-header-description').value=this.ExtensionVersion();
		// hide about button...
		if (!window.opener.gExtensionsViewController) {
			var about = document.getElementById("qp-About");
			if (about)
				about.style["visibility"]="hidden";
		}

	},

	displayOptions: function() {
		window.openDialog('chrome://quickpasswords/content/quickpassword_options.xul','quickfolders-passwords','chrome,titlebar,centerscreen,modal,resizable').focus();
	}

}
